
//------------------------------------------------------------------
#property link      ""
#property copyright ""
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrLime
#property indicator_color2  clrRed
#property strict
//
//
//
//
//

extern int    AdxPeriod       = 14;
extern bool   alertsOn        = false;            // Turn alerts on?
extern bool   alertsOnCurrent = false;            // Alerts on still opened bar?
extern bool   alertsMessage   = true;             // Alerts should display message?
extern bool   alertsSound     = false;            // Alerts should play a sound?
extern bool   alertsNotify    = false;            // Alerts should send a notification?
extern bool   alertsEmail     = false;            // Alerts should send an email?
extern string soundFile       = "alert2.wav";     // Sound file
extern int    UpArrowSize     = 2;                // Up Arrow size
extern int    DnArrowSize     = 2;                // Down Arrow size
extern int    UpArrowCode     = 159;              // Up Arrow code
extern int    DnArrowCode     = 159;              // Down arrow code
extern double UpArrowGap      = 0.5;              // Up Arrow gap        
extern double DnArrowGap      = 0.5;              // Dn Arrow gap
extern color  UpArrowColor    = clrLimeGreen;     // Up Arrow Color
extern color  DnArrowColor    = clrOrange;        // Down Arrow Color


//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);  
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,UpArrowSize,UpArrowColor); SetIndexArrow(0,UpArrowCode);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,DnArrowSize,DnArrowColor); SetIndexArrow(1,DnArrowCode);
   SetIndexBuffer(2,trend);
   return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double adxplus  = iADX(NULL,0,AdxPeriod,PRICE_CLOSE,MODE_PLUSDI, i);
      double adxminus = iADX(NULL,0,AdxPeriod,PRICE_CLOSE,MODE_MINUSDI,i);
      trend[i] = (i<Bars-1) ? (adxplus>adxminus) ? 1 : (adxplus < adxminus) ? -1 : trend[i+1] : 0;  
      
          if (i<Bars-1 && trend[i]!=trend[i+1])
          {
             if (trend[i] ==  1) CrossUp[i] = Low[i] - iATR(NULL,0,15,i)*UpArrowGap;
             if (trend[i] == -1) CrossDn[i] = High[i]+iATR(NULL,0,15,i) *DnArrowGap;
          }

    }
         
    if (alertsOn)
    {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(" crossing up");
         else  doAlert(" crossing down");       
   }
return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," adx  ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Adx ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

